/* $Header: AQDemoServlet22.java 20-feb-2002.10:16:25 rbhyrava Exp $ */

/* Copyright (c) 2001, 2002, Oracle Corporation.  All rights reserved.  */

/*
   DESCRIPTION
    AQ Demo Servlet to process AQ XML requests 
    SID, HOST,PORT need to be modified accordingly.

   PRIVATE CLASSES
    <list of private classes defined - with one-line descriptions>

   NOTES
    <other useful comments, qualifications, etc.>

   MODIFIED    (MM/DD/YY)
    rbhyrava    02/20/02 - set host,port,sid
    rbhyrava    04/12/01 - Merged rbhyrava_aqxmldemos
    rbhyrava    04/02/01 - Creation
 */

/**
 *  @version $Header: AQDemoServlet22.java 20-feb-2002.10:16:25 rbhyrava Exp $
 *  @author  rbhyrava
 *  @since   release specific (what release of product did this appear in)
 */


import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import oracle.AQ.*;
import oracle.AQ.xml.*;
import java.sql.*;
import oracle.jms.*;
import javax.jms.*;
import java.io.*;
import oracle.jdbc.pool.*;

/**
 * This is a sample AQ Servlet for Servlet 2.2 configurations.
 * Eg: Tomcat, OSE 
 */
public class AQDemoServlet22 extends oracle.AQ.xml.AQxmlServlet
{

  //========================================================================
  /*
   *  getDBDrv - specify the database to which the servlet will connect
   */
  public AQxmlDataSource createAQDataSource() throws AQxmlException
  {
    AQxmlDataSource  db_drv = null;
    String sid = "bicp";
    String port = "1521";
    String host = "iasdb";

    System.err.println("AQDemoServlet - setting db driver using");
    System.err.println("sid:" + sid + " port:" + port + " host:" + host ) ;

    System.err.println("AQDemoServlet22 - setting db driver");
    System.err.print("DataSource using sid:host:port "+ 
                     sid + ":" + host + ":" + port)  ;
    db_drv = new AQxmlDataSource("scott", "tiger", sid, host, port);
    System.err.print("sid: "+ db_drv.getSid() ) ;
    System.err.print(" host: "+ db_drv.getHost() ) ;
    System.err.print(" port: "+ db_drv.getPort() ) ;
    System.err.print(" cachesize: "+ db_drv.getCacheSize() ) ;
    System.err.println(" cachescheme: "+ db_drv.getCacheScheme() ) ;

    return db_drv;
  }

  public void init()
  {

     try {
      // AQxmlDebug.setTraceLevel(5);
      // AQxmlDebug.setDebug(true);
      AQxmlDataSource axds = this.createAQDataSource() ;
      setAQDataSource(axds) ;
       System.err.println("init done.") ;
     } catch ( Exception e ) { 
       System.err.println("Error in init(): " + e ) ;
     }
  }
}
