/* $Header: AQPropServlet.java 20-feb-2002.10:16:35 rbhyrava Exp $ */

/* Copyright (c) 2001, 2002, Oracle Corporation.  All rights reserved.  */

/*
   DESCRIPTION
    <short description of component this file declares/defines>

   PRIVATE CLASSES
    <list of private classes defined - with one-line descriptions>

   NOTES
    <other useful comments, qualifications, etc.>

   MODIFIED    (MM/DD/YY)
    rbhyrava    02/20/02 - set host,port,sid
    rbhyrava    05/09/01 - Init for Jserv
    rbhyrava    04/12/01 - Merged rbhyrava_aqxmldemos
    rbhyrava    04/10/01 - comments
    rbhyrava    03/30/01 - Creation
 */

/**
 *  @version $Header: AQPropServlet.java 20-feb-2002.10:16:35 rbhyrava Exp $
 *  @author  rbhyrava
 *  @since   release specific (what release of product did this appear in)
 */

/*
  AQ Propagation Servlet
*/
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import oracle.AQ.*;
import oracle.AQ.xml.*;
import java.sql.*;
import oracle.jms.*;
import javax.jms.*;
import java.io.*;
import oracle.jdbc.pool.*;

/**
 * This is a  AQ Propagation Servlet.
 */
public class AQPropServlet extends oracle.AQ.xml.AQxmlServlet20
{

  /*====================================================================*
   *  getDBDrv - specify the database to which the servlet will connect *
   *====================================================================*/
  public AQxmlDataSource createAQDataSource() throws AQxmlException
  {
    AQxmlDataSource  db_drv = null;

    String sid = "bicp";
    String port = "1521";
    String host = "iasdb";

    System.err.println("AQPropServlet - setting db driver using");
    System.err.println("sid:" + sid + " port:" + port + " host:" + host ) ;

    System.err.println("AQPropServlet - setting db driver");
    db_drv = new AQxmlDataSource("scott", "tiger", sid, host, port);
    System.err.print("sid: "+ db_drv.getSid() ) ;
    System.err.print(" host: "+ db_drv.getHost() ) ;
    System.err.print(" port: "+ db_drv.getPort() ) ;
    System.err.print(" cachesize: "+ db_drv.getCacheSize() ) ;
    System.err.println(" cachescheme: "+ db_drv.getCacheScheme() ) ;
    return db_drv;
  }

 public void init(ServletConfig cfg)
  {
      try
      {
          super.init(cfg) ;
          /*
          AQxmlDebug.setTraceLevel(5);
          AQxmlDebug.setDebug(true);
          AQxmlDebug.setLogStream(System.err);
          */
          AQxmlDataSource dt_src = this.createAQDataSource();
          setAQDataSource(dt_src);
          setSessionMaxInactiveTime(180) ;
      }
      catch (Exception ex)
      {
          System.err.println("Exception in init: " + ex);
      }
  }
}

