Rem
Rem $Header: aqxmlusr.sql 08-feb-2002.15:39:49 weiwang Exp $
Rem
Rem aqxmlusr.sql
Rem
Rem Copyright (c) 2001, 2002, Oracle Corporation.  All rights reserved.  
Rem
Rem    NAME
Rem      aqxmlusr.sql - setup Database/Internet Users 
Rem
Rem    DESCRIPTION
Rem      This sql file is used to create AQ adminstrator , aq database user
Rem      and grant required privileges to AQ internet super user and also 
Rem      grant database access to  internet AQ agents  
Rem
Rem    NOTES
Rem      
Rem
Rem    MODIFIED   (MM/DD/YY)
Rem    rbhyrava    02/08/02 - remove additional grants
Rem    rbhyrava    04/12/01 - Merged rbhyrava_aqxmldemos
Rem    rbhyrava    04/11/01 - Created
Rem

SET FEEDBACK 1
SET NUMWIDTH 10
SET LINESIZE 80
SET TRIMSPOOL ON
SET TAB OFF
SET PAGESIZE 100
SET ECHO ON

SET SERVEROUTPUT ON 
REM 
REM create admin and user accounts and grant http access to user
REM
CONNECT sys/change_on_install AS SYSDBA ;

GRANT CONNECT, RESOURCE, AQ_ADMINISTRATOR_ROLE 
TO aqxmladmn IDENTIFIED BY aqxmladmn;

GRANT CONNECT, RESOURCE, AQ_USER_ROLE 
TO aqxmluser IDENTIFIED BY aqxmluser;

GRANT EXECUTE ON dbms_lock TO PUBLIc ;

REM
REM grant access to admin packages 
REM
GRANT EXECUTE ON dbms_aqadm TO aqxmladmn;
GRANT EXECUTE ON dbms_aq TO aqxmluser;

REM 
REM Grant Create proxy session privileges to AQ servlet super-user  
REM 
GRANT CREATE SESSION TO scott;
ALTER USER aqxmluser GRANT CONNECT THROUGH scott;

REM
REM Create AQ Agent to access AQ Servlet using HTTP
REM
EXECUTE dbms_aqadm.create_aq_agent(agent_name=>'john', enable_http =>true);

REM
REM Map AQ Agent to Database user 
REM
EXECUTE dbms_aqadm.enable_db_access('john', 'aqxmluser');

REM
REM view registered AQ agents
REM
SELECT agent_name, db_username, http_enabled 
FROM aq$internet_users ;

