/* $Header: template.java 23-feb-98.17:15:00 etucker Exp $ */

/* Copyright (c) Oracle Corporation 2000. All Rights Reserved. */

/*
   DESCRIPTION
    <short description of component this file declares/defines>

   PRIVATE CLASSES
    <list of private classes defined - with one-line descriptions>

   NOTES
    <other useful comments, qualifications, etc.>

   MODIFIED    (MM/DD/YY)
    mpjoshi     05/19/00 - Creation
 */

/**
 *  @version $Header: template.java 23-feb-98.17:15:00 etucker Exp $
 *  @author  mpjoshi 
 *  @since   release specific (what release of product did this appear in)
 */

import java.io.InputStream;
import java.io.OutputStream;

// Core JDBC classes: 
import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

// Oracle Specific JDBC classes: 
import oracle.sql.*;
import oracle.jdbc.driver.*;
public class Ex2_66
{
  static final int MAXBUFSIZE = 32767;

  public static void main (String args [])
       throws Exception
  {
    // Load the Oracle JDBC driver: 
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());

    // Connect to the database: 
    Connection conn =
    DriverManager.getConnection ("jdbc:oracle:oci8:@", "samp", "samp");

    // It's faster when auto commit is off: 
    conn.setAutoCommit (false);

    // Create a Statement: 
    Statement stmt = conn.createStatement ();
    try
    {
     CLOB lob_loc = null;
     String buf = "Some Text To Write";
     ResultSet rset = stmt.executeQuery (
        "SELECT intab.transcript FROM TABLE( "
           +" SELECT mtab.inseg_ntab FROM multimedia_tab mtab "
           +"WHERE mtab.clip_id = 1) intab WHERE intab.segment=1 FOR UPDATE");
   if (rset.next())
   {
     lob_loc = ((OracleResultSet)rset).getCLOB (1);
   }

       OracleCallableStatement cstmt = (OracleCallableStatement) 
          conn.prepareCall ("BEGIN DBMS_LOB.OPEN( ?, "
                            +"DBMS_LOB.LOB_READWRITE); END;");
   cstmt.setCLOB(1, lob_loc);
   cstmt.execute();
   long pos = 0; // This is the offset in the CLOB where data is to be written
   long length = 0; // This is the size of the buffer to be written.

   // This loop writes the buffer three times consecutively: 
   for (int i = 0; i < 3; i++)
   {
      // Fill the buffer with some data to be written: 
      length = buf.length();
      pos += length;
      // This is an Oracle-specific method: 
      lob_loc.putString(pos, buf);
   }

   // All OPENed LOBS must be CLOSEd: 
       cstmt = (OracleCallableStatement) conn.prepareCall (
          "BEGIN DBMS_LOB.CLOSE(?); END;");
   cstmt.setCLOB(1, lob_loc);
   cstmt.execute();
   stmt.close();
   cstmt.close();
   conn.commit();
   conn.close();
    }
    catch (SQLException e)
    {
       e.printStackTrace();
    }
  }
}
